;nyquist plug-in
;version 2
;type generate
;name "Drum Machine (sound files)..."
;action "Generating Rhythm..."
;info "by Steve Daulton. (www.easyspacepro.com) Released under GPL v2."


;; SFDrumMachine.ny by Steve Daulton May 2012.
;; Released under terms of the GNU General Public License version 2:
;; http://www.gnu.org/licenses/old-licenses/gpl-2.0.html .

;; If file not found a default synth drum is used.
;; Not much error checking in this so be careful :=)

;control tempo "Tempo" real "bpm" 120 30 300
;control timesig "Time signature" int "beats per bar" 4 1 6
;control bars "Number of bars" int "" 12 1 100
;control drums "Number of drums" int "" 4 1 4
;control file1 "Sound file drum 1" string "Fully qualified path" "" 
;control beatnum1 "Which beat of bar" real "drum 1" 1 1 6
;control file2 "Sound file drum 2" string "Fully qualified path" "" 
;control beatnum2 "Which beat of bar" real "drum 2" 2 1 6
;control file3 "Sound file drum 3" string "Fully qualified path" "" 
;control beatnum3 "Which beat of bar" real "drum 3" 3 1 6
;control file4 "Sound file drum 4" string "Fully qualified path" "" 
;control beatnum4 "Which beat of bar" real "drum 4" 3.5 1 6

(defun makerhythm (file beatnum)
  (setf kdrum (if (test file)
                (mono (s-read file))
                (default-drum)))
  (let* ((beatlen (/ 60.0 tempo))
           (barlen (* beatlen timesig))
           (offset (* beatlen (1- beatnum)))
           (boffset offset))
    (dotimes (bar bars)
      (setq offset (+ boffset (* bar barlen)))
      (setf result (sim result (at-abs offset (cue kdrum)))))
    result))

(defun test (fname)
  (if (open-binary fname) T nil))

(defun default-drum ()
  (stretch-abs 0.3
    (clip 
      (mult (pwlv 10 0.1 4 0.2 0.5 0.5 0.1 1 0)
            (lp (noise 1) (pwlv 120 1 1)))
    0.8)))

;;; make stereo sounds mono
(defun mono (s-in)
  (if (arrayp s-in)
    (mult 0.5 (sum (aref s-in 0)(aref s-in 1)))
    s-in))

(setf result (s-rest 0))
(case drums
  (1 (makerhythm file1 beatnum1))
  (2 (makerhythm file1 beatnum1)
     (makerhythm file2 beatnum2))
  (3 (makerhythm file1 beatnum1)
     (makerhythm file2 beatnum2)
     (makerhythm file3 beatnum3))
  (4 (makerhythm file1 beatnum1)
     (makerhythm file2 beatnum2)
     (makerhythm file3 beatnum3)
     (makerhythm file4 beatnum4)))